/*********************************************************************************
 * nl_send: permette di spedire un messaggio al etlink del kernel creato con il
 * modulo nl.
 * Il socket NETLINK  descritto da un header di tipo sockaddr_nl accessibile
 * aprendo il socket in moalit RAW
 * -------------------------------------------------------------------------------
 * BUG: con kernel 2.6.13.1 e compilatore 3.3.6 credo ci sia un bug perch
 * sys/socket.h deve andare prima di linux/netlink.h, ma non capisco perch visto
 * che le macro di esclusione sono diverse!! _
 *********************************************************************************/

#include <stdio.h>
#include <sys/socket.h>    // deve essere prima di netlink.h altrimenti non si compila nulla!  un baco credo ma non capisco perch visto che le macro di esclusione sono diverse
#include <linux/netlink.h>

#include "nl.h"

int sock_fd;
struct sockaddr_nl src_addr, dest_addr;
struct nlmsghdr *nlh;
struct msghdr msg; 
struct iovec iov;

int main(int argc, char **argv)
{  
   sock_fd = socket(PF_NETLINK,    // il socket  un Kernel User Interface Device
		    SOCK_RAW,      // acesso grezzo (RAW)
		    NETLINK_TEST); // 16  lo stesso numero definito nel kernel
   
   src_addr.nl_family = AF_NETLINK;
   src_addr.nl_pid    = getpid();
   src_addr.nl_groups = 0;         // gruppo a cui interessano i messaggi multicast. Se 0 non ci sono multicast
   
   if(bind(sock_fd, (struct sockaddr*)&src_addr,
	   sizeof(src_addr)))
     goto exit_;
   
   memset(&dest_addr, 0, sizeof(src_addr));
   dest_addr.nl_family= AF_NETLINK;
   dest_addr.nl_pid   = 0;         // messaggio destinato al kernel
   dest_addr.nl_groups= 0;         // unicast
   
   nlh = (struct nlmsghdr*)malloc(NLMSG_SPACE(MAX_PAYLOAD_LENGTH));
   nlh->nlmsg_len = NLMSG_SPACE(MAX_PAYLOAD_LENGTH);
   nlh->nlmsg_pid = getpid();  /* self pid, ma non serve */
   nlh->nlmsg_flags = 0;
   /* Fill in the netlink message payload */
   if(argc > 1)
     strcpy(NLMSG_DATA(nlh), argv[1]);
   else
     strcpy(NLMSG_DATA(nlh), "Calzo Message!!");
   
   iov.iov_base = (void *)nlh;
   iov.iov_len = nlh->nlmsg_len;
   msg.msg_name = (void *)&dest_addr;
   msg.msg_namelen = sizeof(dest_addr);
   msg.msg_iov = &iov;
   msg.msg_iovlen = 1;

   printf("Proces %d send '%s' message...\n", nlh->nlmsg_pid, NLMSG_DATA(nlh));
   sendmsg(sock_fd, &msg, 0);

exit_:
   close(sock_fd);
   return 0;
}

