#ifndef __NL_H__
#define __NL_H__

#define NETLINK_TEST        30    // protocollo di test inventato da noi
#define MAX_PAYLOAD_CHAR    100   // dimensione della stringa del paylod per la struttura nl_payload_t
#define MAX_PAYLOAD_LENGTH  sizeof(struct nl_payload_t)   // dimensione dei dati utili incapsulati

#ifndef __KERNEL__
 #define str_l(x) "%"#x"s"
 #define str_lim(x) str_l(x)
#endif

/** Questa struttura  definita arbitrariamente e deve contenere il pid del
 * processo mittente e i dati da stampare eventualmente. Il campo `multicast'
 * indica se dovr reinviare un messaggio multicast o no e verr implementato
 * dalla versione 04 in poi.
 * */
typedef struct nl_payload_t 
{
   int pid;                     // Proce ID a cui il kernel invier il messaggio
   unsigned multicast;          // Bitmask per comunicazione multicast: OR dei gruppi interessati a cui il kernel invier il messaggio
   char str[MAX_PAYLOAD_CHAR];  // Stringa dati... tanto per avere qualche cosa da stampare
} nl_payload_t;


#endif // __NL_H__
